> For the complete documentation index, see [llms.txt](https://docs.wisej.com/api/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wisej.com/api/wisej.core/interfaces/wisej.core.iwisejdatastore.md).

# IWisejDataStore

Namespace: **Wisej.Core**

Assembly: **Wisej.Framework** (4.0.0.0)

All wisej data stores implement this interface.

{% tabs %}
{% tab title="C#" %}

```csharp
public interface IWisejDataStore
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Interface IWisejDataStore
```

{% endtab %}
{% endtabs %}

## Methods

### ![](/files/hsR4ok3152WyAf8J2C1u) OnDataCount()

Returns the number of available records.

**Returns:** [Int32](https://docs.microsoft.com/dotnet/api/system.int32). The total number of rows.

### ![](/files/hsR4ok3152WyAf8J2C1u) OnDataRead(data)

Returns a data object.

| Parameter | Type                                                          | Description                                                                                                                                                                                                               |
| --------- | ------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **data**  | [Object](https://docs.microsoft.com/dotnet/api/system.object) | Request parameters. The parameters depend on the data consumer. For example, the [DataGridView](/api/wisej.web/lists-and-grids/datagridview.md) control uses: first, last, sortIndex, and sortDirection("asc" or "desc"). |

**Returns:** [Object](https://docs.microsoft.com/dotnet/api/system.object). An object that contains the data requested by the component.

## Implemented By

| Name                                                           | Description                                                                                                                   |
| -------------------------------------------------------------- | ----------------------------------------------------------------------------------------------------------------------------- |
| [DataGridView](/api/wisej.web/lists-and-grids/datagridview.md) | Represents a data grid control.                                                                                               |
| [ListView](/api/wisej.web/lists-and-grids/listview.md)         | Represents a list view control, which displays a collection of items that can be displayed using one of four different views. |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.wisej.com/api/wisej.core/interfaces/wisej.core.iwisejdatastore.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
